var gSSLStatus;
var gCert;

function badCertListener() {}

badCertListener.prototype = {
  getInterface: function (aIID) {
    return this.QueryInterface(aIID);
  },
  QueryInterface: function(aIID) {
    if (aIID.equals(Components.interfaces.nsIBadCertListener2) ||
        aIID.equals(Components.interfaces.nsIInterfaceRequestor) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },
  notifyCertProblem: function MSR_notifyCertProblem(socketInfo, sslStatus, targetHost) {
    gSSLStatus = sslStatus;
    if (gSSLStatus)
      gCert = gSSLStatus.QueryInterface(Components.interfaces.nsISSLStatus).serverCert;
    return true; // suppress error UI
  }
}


var sslhazard = {
  onLoad: function() {
    this.initialized = true;
  },

  onSSLHazardOverride: function() {
    //if(!this.initialized)
    //  return;

    //alert("hello from ssl hazard");

    var overserv = Components.classes["@mozilla.org/security/certoverride;1"]
                   .getService(Components.interfaces.nsICertOverrideService);
    var recentserv = Components.classes["@mozilla.org/security/recentbadcerts;1"]
                     .getService(Components.interfaces.nsIRecentBadCertsService);
    var fus = Components.classes["@mozilla.org/docshell/urifixup;1"]
                        .getService(Components.interfaces.nsIURIFixup);
  
    //if (overserv) alert("have overserv");
    //if (recentserv) alert("have recentserv");
    //if (fus) alert("have fus");

    //alert("location is " + window.content.document.location);
    var uri = fus.createFixupURI(window.content.document.location, 0);
  
    //if (uri) alert("have uri");
    if (!uri) return;
    if (uri.scheme == "http") uri.scheme = "https";
    if (uri.port == -1) uri.port = 443;

    var hostWithPort = uri.host + ":" + uri.port;
    gSSLStatus = recentserv.getRecentBadCert(hostWithPort);
    //if (gSSLStatus) alert("have sslstatus");
    if (!gSSLStatus)
    {
      var req = new XMLHttpRequest();
      try {
        if(uri) {
          req.open('GET', uri.prePath, false);
          req.channel.notificationCallbacks = new badCertListener();
          req.send(null);
        }
      } catch (e) {
      } finally {
      }
    
      if(req.channel && req.channel.securityInfo) {
        const Ci = Components.interfaces;
        gSSLStatus = req.channel.securityInfo
                     .QueryInterface(Ci.nsISSLStatusProvider).SSLStatus;
        gCert = gSSLStatus.QueryInterface(Ci.nsISSLStatus).serverCert;
      }
    }

    gCert = gSSLStatus.QueryInterface(Components.interfaces.nsISSLStatus).serverCert;
    //if (gCert) alert("have cert");
    if (!gCert) return;

    var flags = 0;
    if(gSSLStatus.isUntrusted)
      flags |= overserv.ERROR_UNTRUSTED;
    if(gSSLStatus.isDomainMismatch)
      flags |= overserv.ERROR_MISMATCH;
    if(gSSLStatus.isNotValidAtThisTime)
      flags |= overserv.ERROR_TIME;

    overserv.rememberValidityOverride(
      uri.asciiHost, uri.port,
      gCert,
      flags,
      true);

    BrowserReloadSkipCache();
  }
};

window.addEventListener("load", function(e) { sslhazard.onLoad(e); }, false); 
